# Operations Research API

The Operations Research API aims to solve high-level operations research problems using linear programming, mixed integer programming, constraint programming and more. It provides optimization solutions for specific problems to external users through an API call.

## Service: optimization.googleapis.com

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://optimization.googleapis.com`

## REST Resource: [v1.mathopt](https://developers.google.com/optimization/service/reference/rest/v1/mathopt)

| Methods ||
|---|---|
| `https://developers.google.com/optimization/service/reference/rest/v1/mathopt/solveMathOptModel` | `POST /v1/mathopt:solveMathOptModel` Solves the input model and returns the result at once. |

## REST Resource: [v1.scheduling](https://developers.google.com/optimization/service/reference/rest/v1/scheduling)

| Methods ||
|---|---|
| `https://developers.google.com/optimization/service/reference/rest/v1/scheduling/solveShiftGeneration` | `POST /v1/scheduling:solveShiftGeneration` Solves a shift generation problem from the given `SolveShiftGenerationRequest` by generating shifts from given shift templates in order to cover the employee demand. |
| `https://developers.google.com/optimization/service/reference/rest/v1/scheduling/solveShiftScheduling` | `POST /v1/scheduling:solveShiftScheduling` Solves a fixed shift scheduling problem from the given `SolveShiftSchedulingRequest` by assigning employees to shifts such that employees' scheduling preferences are maximized and scheduling constraint violations are minimized. |

## REST Resource: [v1.shipping](https://developers.google.com/optimization/service/reference/rest/v1/shipping)

| Methods ||
|---|---|
| `https://developers.google.com/optimization/service/reference/rest/v1/shipping/designShippingNetwork` | `POST /v1/shipping:designShippingNetwork` Solves the liner shipping network design and scheduling problem (LSNDSP) from the given `DesignShippingNetworkRequest`. |